<?php

namespace FiloBlu\GuestWishlist\Block\Customer;

class Wishlist extends \Magento\Wishlist\Block\Customer\Wishlist {

    protected $_helper;

    public function __construct(
    \Magento\Catalog\Block\Product\Context $context, \Magento\Framework\App\Http\Context $httpContext, \Magento\Catalog\Helper\Product\ConfigurationPool $helperPool, \Magento\Customer\Helper\Session\CurrentCustomer $currentCustomer, \Magento\Framework\Data\Helper\PostHelper $postDataHelper, \FiloBlu\GuestWishlist\Helper\Data $helper, array $data = []
    ) {
        $this->_helper = $helper;
        parent::__construct($context, $httpContext, $helperPool, $currentCustomer, $postDataHelper);
    }

    /**
     * @return string
     */
    protected function _toHtml() {

        if ($this->_helper->getConfig("general/enabled")) {
            return \Magento\Wishlist\Block\AbstractBlock::_toHtml();
        } else {
            return parent::_toHtml();
        }
    }

    /**
     * Preparing global layout
     *
     * @return void
     */
    protected function _prepareLayout() {
        if ($this->_helper->getConfig("general/enabled")) {
            $this->setTemplate("Magento_Wishlist::view.phtml");
            parent::_prepareLayout();
        } else {
            parent::_prepareLayout();
        }
    }

}
